routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanieController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\Auth\SocialiteController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes([
    'register' => false
]);

Route::get('/auth/redirect/{provider}',[SocialiteController::class,'redirect'])->name('auth.redirect');
Route::get('/auth/callback/{provider}',[SocialiteController::class,'callback'])->name('auth.callback');

Route::middleware('auth')->group(function(){
    
    Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => App\Http\Controllers\LanguageController::class,'switch']);

    Route::get('/', function () {
        return view('home');
    });

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('employees',EmployeeController::class)->except(['destroy']);
    Route::get('/employees/{employee}/destroy',[EmployeeController::class,'destroy'])->name('employees.destroy');
    
    Route::resource('companies',CompanieController::class)->except(['destroy']);
    Route::get('/companies/{company}/destroy',[CompanieController::class,'destroy'])->name('companies.destroy');
    
});

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Employee extends Model
{
    use HasFactory;

    protected $fillable = [
        'first_name',
        'last_name',
        'companie_id',
        'email',
        'phone'
    ];

    public function companie(){
        return $this->belongsTo(Companie::class);
    }
    
}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Companie;
use App\Models\Employee;
use Illuminate\Http\Request;
use App\Http\Requests\EmployeeStoreRequest;

class EmployeeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // $employees = Employee::latest()->paginate(10);
        // return view('employee.index',compact('employees'));
        return view('employee.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $companies = Companie::select('id','name')->latest()->get();
        return view('employee.create',compact('companies'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(EmployeeStoreRequest $request)
    {
        Employee::create([
            'first_name' => $request->first_name,
            'last_name' => $request->last_name,
            'companie_id' => $request->companie_id,
            'email' => $request->email,
            'phone' => $request->phone
        ]);

        return redirect()->route('employees.create')->with('message',['text' => __('employee.status2'), 'class' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Employee $employee)
    {
        $companies = Companie::select('id','name')->get();
        return view('employee.edit',compact('employee','companies'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(EmployeeStoreRequest $request, Employee $employee)
    {
        $employee->update([
            'first_name' => $request->first_name,
            'last_name' => $request->last_name,
            'companie_id' => $request->companie_id,
            'email' => $request->email,
            'phone' => $request->phone
        ]);

        return redirect()->route('employees.edit',$employee->id)->with('message',['text' => __('employee.status3'), 'class' => 'success']);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Employee $employee)
    {
        $employee->delete();
        return redirect()->route('employees.index')->with('message',['text' => __('employee.status4'), 'class' => 'success']);
    }
}

app/View/Components/Employees.php
<?php

namespace App\View\Components;

use App\Models\Employee;
use Illuminate\View\Component;

class Employees extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $employees = Employee::count();
        return view('components.employees',compact('employees'));
    }
}

resources/views/employee/create.blade.php
@extends('layouts.app')
@section('title')
{{ __('employee.title2') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')
        
        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ __('employee.title2') }}
                    <a href="{{ route('employees.index') }}" class="btn btn-sm btn-secondary float-right">{{ __('employee.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('employees.store')}}" method="POST">
                        @csrf
                        <div class="row">
                            <div class="col-6">
                                <label for="">{{ __('employee.table1') }}</label>
                                <input type="text" class="form-control" name="first_name" value="{{ old('first_name')}}">
                                @include('layouts.error', ['name' => 'first_name'])
                            </div>
                            <div class="col-6">
                                <label for="">{{ __('employee.table2') }}</label>
                                <input type="text" class="form-control" name="last_name" value="{{ old('last_name')}}">
                                @include('layouts.error', ['name' => 'last_name'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-md-12">
                                <label for="">{{ __('employee.table3') }}</label>
                                <select name="companie_id" class="form-control">
                                    <option value="" selected disabled>Select Companie</option>
                                    @forelse ($companies as $companie)
                                        <option value="{{ $companie->id }}">{{ $companie->name }}</option>
                                    @empty
                                        <option value="" selected>{{ __('employee.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'companie_id'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-6">
                                <label for="">{{ __('employee.table4') }}</label>
                                <input type="email" class="form-control" name="email" value="{{ old('email')}}">
                                @include('layouts.error', ['name' => 'email'])
                            </div>
                            <div class="col-6">
                                <label for="">{{ __('employee.table5') }}</label>
                                <input type="text" class="form-control" name="phone" value="{{ old('phone')}}">
                                @include('layouts.error', ['name' => 'phone'])
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit">{{ __('employee.btn1') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employee/edit.blade.php
@extends('layouts.app')
@section('title')
 {{ __('employee.title3') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')
        
        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                     {{ __('employee.title3') }}
                    <a href="{{ route('employees.index') }}" class="btn btn-sm btn-secondary float-right"> {{ __('companie.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('employees.update',$employee->id)}}" method="POST">
                        @csrf
                        @method('PUT')
                        <div class="row">
                            <div class="col-6">
                                <label for=""> {{ __('employee.table1') }}</label>
                                <input type="text" class="form-control" name="first_name" value="{{ $employee->first_name }}">
                                @include('layouts.error', ['name' => 'first_name'])
                            </div>
                            <div class="col-6">
                                <label for=""> {{ __('employee.table2') }}</label>
                                <input type="text" class="form-control" name="last_name" value="{{ $employee->last_name }}">
                                @include('layouts.error', ['name' => 'last_name'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-md-12">
                                <label for=""> {{ __('employee.table3') }}</label>
                                <select name="companie_id" class="form-control">
                                    <option value="" disabled>Select Companie</option>
                                    @forelse ($companies as $companie)
                                        @php
                                            if($companie->id == $employee->companie_id){
                                                $select = "selected";
                                            }else{
                                                $select = "";
                                            }
                                            echo "<option $select value='$companie->id'>".$companie['name']."</option>"
                                        @endphp
                                    @empty
                                        <option value="" selected> {{ __('employee.status1') }}</option>
                                    @endforelse
                                </select>
                                @include('layouts.error', ['name' => 'companie_id'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-6">
                                <label for=""> {{ __('employee.table4') }}</label>
                                <input type="email" class="form-control" name="email" value="{{ $employee->email }}">
                                @include('layouts.error', ['name' => 'email'])
                            </div>
                            <div class="col-6">
                                <label for=""> {{ __('employee.table5') }}</label>
                                <input type="text" class="form-control" name="phone" value="{{ $employee->phone }}">
                                @include('layouts.error', ['name' => 'phone'])
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit"> {{ __('employee.title3') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employee/index.blade.php
@extends('layouts.app')
@section('title')
{{ __('employee.title1') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ __('employee.title1') }}
                    <a href="{{ route('employees.create')}}" class="btn btn-sm btn-primary float-right">{{ __('employee.btn1') }}</a>
                </div>
                <div class="card-body">
                    <table class="table text-center table-bordered table-striped" id="EmployeesTable">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>{{ __('employee.table1') }}</th>
                                <th>{{ __('employee.table2') }}</th>
                                <th>{{ __('employee.table3') }}</th>
                                <th>{{ __('employee.table4') }}</th>
                                <th>{{ __('employee.table5') }}</th>
                                <th>{{ __('employee.table6') }}</th>
                            </tr>
                        </thead>
                        <tbody>     
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
<script type="text/javascript">
    $(document).ready( function () {
        $.noConflict();
        $('#EmployeesTable').DataTable({
            "processing": true,
            "serverSide": true,
            "responsive": true,
            "ajax": "{{ route('api.employees') }}",
            "columns": [
                { "data": "DT_RowIndex", name:'DT_RowIndex'},
                { "data": "first_name" },
                { "data": "last_name" },
                { "data": "companie.name" },
                { "data": "email" },
                { "data": "phone" },
                { "data": "action", name:'action', orderable: false, searchable: false }
            ]
        });

    } );
</script>
@endsection